Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class CastableExpression

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.expr.UnaryExpression
              net.sf.saxon.expr.CastableExpression

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

public final class CastableExpression
extends UnaryExpression

Castable Expression: implements "Expr castable as atomic-type?". The implementation simply wraps a cast expression with a try/catch.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.UnaryExpression
`operand`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`CastableExpression(Expression source, AtomicType target, boolean allowEmpty)`

Method Summary
`Expression` | `analyze(StaticContext env, ItemType contextItemType)` Type-check the expression
`int` | `computeCardinality()` Determine the static cardinality.
`int` | `computeSpecialProperties()` Determine the special properties of this expression
`protected java.lang.String` | `displayOperator(NamePool pool)` Give a string representation of the operator for use in diagnostics
`boolean` | `effectiveBooleanValue(XPathContext context)` Get the effective boolean value of the expression.
`boolean` | `equals(java.lang.Object other)` Is this expression the same as another expression?
`Item` | `evaluateItem(XPathContext context)` Evaluate the expression
`ItemType` | `getItemType()` Determine the data type of the result of the Castable expression
`Expression` | `simplify(StaticContext env)` Simplify the expression

Methods inherited from class net.sf.saxon.expr.UnaryExpression
`display, getBaseExpression, hashCode, iterateSubExpressions, promote`

Methods inherited from class net.sf.saxon.expr.ComputedExpression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, dynamicError, dynamicError, evaluateAsString, getCardinality, getColumnNumber, getConstructType, getDependencies, getExecutable, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getParentExpression, getPublicId, getSpecialProperties, getSystemId, iterate, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CastableExpression

    public CastableExpression(Expression source,
                              AtomicType target,
                              boolean allowEmpty)

Method Detail

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify the expression

  Specified by:
    `simplify` in interface `Expression`
  Overrides:
    `simplify` in class `UnaryExpression`
  Returns:
    the simplified expression
  Throws:
    `XPathException`

### analyze

    public Expression analyze(StaticContext env,
                              ItemType contextItemType)
                       throws XPathException

  Type-check the expression

  Specified by:
    `analyze` in interface `Expression`
  Overrides:
    `analyze` in class `UnaryExpression`
  Throws:
    `XPathException`

### equals

    public boolean equals(java.lang.Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `UnaryExpression`

### getItemType

    public ItemType getItemType()

  Determine the data type of the result of the Castable expression

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `UnaryExpression`
  Returns:
    the item type of the items in the result sequence, insofar as this is known statically.

### computeCardinality

    public int computeCardinality()

  Description copied from class: `UnaryExpression`
  Determine the static cardinality. Default implementation returns the cardinality of the operand

  Overrides:
    `computeCardinality` in class `UnaryExpression`

### computeSpecialProperties

    public int computeSpecialProperties()

  Determine the special properties of this expression

  Overrides:
    `computeSpecialProperties` in class `UnaryExpression`
  Returns:
    `StaticProperty.NON_CREATIVE`.

### evaluateItem

    public Item evaluateItem(XPathContext context)

  Evaluate the expression

  Specified by:
    `evaluateItem` in interface `Expression`
  Overrides:
    `evaluateItem` in class `ComputedExpression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence

### effectiveBooleanValue

    public boolean effectiveBooleanValue(XPathContext context)

  Description copied from class: `ComputedExpression`
  Get the effective boolean value of the expression. This returns false if the value is the empty sequence, a zero-length string, a number equal to zero, or the boolean false. Otherwise it returns true.

  Specified by:
    `effectiveBooleanValue` in interface `Expression`
  Overrides:
    `effectiveBooleanValue` in class `ComputedExpression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the effective boolean value

### displayOperator

    protected java.lang.String displayOperator(NamePool pool)

  Give a string representation of the operator for use in diagnostics

  Specified by:
    `displayOperator` in class `UnaryExpression`
  Returns:
    the operator, as a string

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD